using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Tao.OpenGl;
using Tao.Platform.Windows;

namespace SineMesh
{
    public partial class SineMeshForm : Form
    {
        private int width=800;
        private int height=600;
        private Rectangle rec;

        public SineMeshForm()
        {
            InitializeComponent();
            this.SetBounds(0, 0, width, height);
            glControl.InitializeContexts();
            initializeOpenGl();
        }
        public void initializeOpenGl()
        {
            
            Gl.glViewport(0, 0, width, height);
            Gl.glMatrixMode(Gl.GL_PROJECTION);
            Gl.glLoadIdentity();
            Gl.glOrtho(-4*800.0/600.0, 4*800.0/600.0, -4, 4, 1, 10);

            Gl.glMatrixMode(Gl.GL_MODELVIEW);
            Gl.glLoadIdentity();
            Glu.gluLookAt(4.5, 2.5, 2.5, 0, 0, 0, 0, 1, 0);

            Gl.glClearColor(0, 0, 0, 1);
            Gl.glClear(Gl.GL_COLOR_BUFFER_BIT);
            Gl.glDisable(Gl.GL_LIGHTING);
            Gl.glDisable(Gl.GL_DOUBLE);
        }

        public void glControl_Paint(object sender, PaintEventArgs e)
        {
            Gl.glClear(Gl.GL_COLOR_BUFFER_BIT);
            sineMesh();            
        }
        public void sineMesh()
        {
            double x,y,z,xSquared,zSquared;
            Gl.glColor3d(0.124, 0.753, 0.162);
            
           
                for (x = -3.0; x <= 3.0; x = x + 0.08)
                {
                    xSquared = x * x;
                    Gl.glBegin(Gl.GL_LINE_STRIP);
                    for (z = -3.0; z < 3.0; z = z + 0.002)
                    {
                        
                        zSquared = z * z;
                        y = 3.5 * Math.Sin(6.0 * Math.Sqrt(xSquared + zSquared)) / (6.0 * Math.Sqrt(xSquared + zSquared));
                        Gl.glVertex3d(x, y, z);                       
                    }
                    Gl.glEnd();
                    glControl.SwapBuffers();                                   
                }
            
                for (z = -3.0; z <= 3.0; z = z + 0.08)
                {
                    zSquared = z * z;
                    Gl.glBegin(Gl.GL_LINE_STRIP);
                        for (x = -3.0; x <3.0; x = x + 0.002)
                        {

                            xSquared = x * x;
                            y = 3.5 * Math.Sin(6.0 * Math.Sqrt(xSquared + zSquared)) / (6.0 * Math.Sqrt(xSquared + zSquared));
                            Gl.glVertex3d(x, y, z);
                        }
                    Gl.glEnd(); 
                    glControl.SwapBuffers();
                }
                        
        }

        public void Form1_Resize(object sender, EventArgs e)
        {
            rec = ClientRectangle;
            width = rec.Width;
            height = rec.Height;
            Gl.glViewport(0, 0, width, height);

            Gl.glMatrixMode(Gl.GL_PROJECTION);
            Gl.glLoadIdentity();
            if (width > height)
                Gl.glOrtho(-4 * width / height, 4 * width / height, -4, 4, 1, 10);
            else
                Gl.glOrtho(-4, 4, -4 * height / width, 4 * height / width, 1, 10);

            Gl.glMatrixMode(Gl.GL_MODELVIEW);
            Gl.glLoadIdentity();
            Glu.gluLookAt(4.5, 2.5, 2.5, 0, 0, 0, 0, 1, 0);
            this.Refresh();
        }
    }
}